\        

\ 10:01 15.08.2010 : handle   commhandle ( chu )
\ 11:31 15.08.2010 :    COMSTAT

\  
-2147483648 CONSTANT GENERIC_READ
1073741824 CONSTANT GENERIC_WRITE
 S" ~day\wincons\wc.f" INCLUDED \   

\  
0 VALUE commhandle
VARIABLE WasRead
VARIABLE ReadBuffer

\ - 
WINAPI: TransmitCommChar KERNEL32.DLL \ ( char commhandle -- ior )
WINAPI: SetCommTimeouts KERNEL32.DLL
WINAPI: GetCommTimeouts KERNEL32.DLL
WINAPI: BuildCommDCBA KERNEL32.DLL
WINAPI: SetCommState KERNEL32.DLL
WINAPI: GetCommState KERNEL32.DLL
WINAPI: WaitCommEvent KERNEL32.DLL
WINAPI: SetCommMask KERNEL32.DLL
WINAPI: GetCommMask 		KERNEL32.DLL
\ 
WINAPI: ClearCommBreak 		KERNEL32.DLL
WINAPI: SetCommBreak 		KERNEL32.DLL
WINAPI: EscapeCommFunction	KERNEL32.DLL
WINAPI: GetCommModemStatus 	KERNEL32.DLL
WINAPI: GetCommProperties 	KERNEL32.DLL
\ WINAPI: CommConfigDialog	KERNEL32.DLL
\ WINAPI: SetDefaultCommConfig 	KERNEL32.DLL^ -2010 Procedure not found
\ WINAPI: GetDefaultCommComfig 	KERNEL32.DLL^ -2010 Procedure not found
WINAPI: SetCommConfig 		KERNEL32.DLL
WINAPI: GetCommConfig 		KERNEL32.DLL
WINAPI: SetupComm 		KERNEL32.DLL
WINAPI: PurgeComm 		KERNEL32.DLL	\ PURGE_TXABORT PURGE_RXABORT PURGE_TXCLEAR PURGE_RXCLEAR
WINAPI: ClearCommError 		KERNEL32.DLL
\
\ WINAPI: CreateEventA		KERNEL32.DLL
\


0
CELL -- Internal
CELL -- InternalHigh
CELL -- Offset
CELL -- OffsetHigh
CELL -- hEvent
CONSTANT OVELAPPED
HERE DUP  OVELAPPED DUP ALLOT ERASE VALUE overlap

VARIABLE Event

0   
CELL -- ReadIntervalTimeout
CELL -- ReadTotalTimeoutMultiplier
CELL -- ReadTotalTimeoutConstant
CELL -- WriteTotalTimeoutMultiplier
CELL -- WriteTotalTimeoutConstant
CONSTANT COMMTIMEOUTS
HERE DUP COMMTIMEOUTS DUP ALLOT ERASE VALUE CommTimeouts

0
CELL -- status
(
    DWORD fCtsHold : 1;   // Tx waiting for CTS signal 
    DWORD fDsrHold : 1;   // Tx waiting for DSR signal 
    DWORD fRlsdHold : 1;  // Tx waiting for RLSD signal 
    DWORD fXoffHold : 1;  // Tx waiting, XOFF char received
    DWORD fXoffSent : 1;  // Tx waiting, XOFF char sent 
    DWORD fEof : 1;       // EOF character sent 
    DWORD fTxim : 1;      // character waiting for Tx 
    DWORD fReserved : 25; // reserved 
)
CELL -- InQue
CELL -- OutQue
CONSTANT COMSTAT
HERE DUP COMSTAT DUP ALLOT ERASE VALUE commstate
VARIABLE commerror

0
CELL -- DCBlength           \ sizeof(DCB) 
CELL -- BaudRate            \ current baud rate 
CELL -- Mode
(     Mode
    ^-- fBinary:1            \ 1 - binary mode, no EOF check 
    ^-- fParity:1            \ 0 - enable parity checking 
    ^-- fOutxCtsFlow:1       \ 0 - CTS output flow control 
    ^-- fOutxDsrFlow:1       \ 0 - DSR output flow control 
    ^-- fDtrControl:2        \ 00 - DTR flow control type 
    ^-- fDsrSensitivity:1    \ 0 - DSR sensitivity 
    ^-- fTXContinueOnXoff:1  \ 0 - XOFF continues Tx 
    ^-- fOutX:1              \ 0 - XON/XOFF out flow control 
    ^-- fInX:1               \ 0 - XON/XOFF in flow control 
    ^-- fErrorChar:1         \ 0 - enable error replacement 
    ^-- fNull:1              \ 0 - enable null stripping 
    ^-- fRtsControl:2        \ 00 - RTS flow control 
    ^-- fAbortOnError:1      \ 0 - abort reads/writes on error 
    ^-- fDummy2:17           \ reserved 
)
2 -- wReserved            \ not currently used 
2 -- XonLim               \ transmit XON threshold 
2 -- XoffLim              \ transmit XOFF threshold 
1 -- ByteSize             \ number of bits/byte, 4-8 
1 -- Parity               \ 0-4=no,odd,even,mark,space 
1 -- StopBits             \ 0,1,2 = 1, 1.5, 2 
1 -- XonChar              \ Tx and Rx XON character 
1 -- XoffChar             \ Tx and Rx XOFF character 
1 -- ErrorChar            \ error replacement character 
1 -- EofChar              \ end of input character 
1 -- EvtChar              \ received event character 
2 -- wReserved1           \ reserved; do not use 
CONSTANT DCB

HERE DUP DCB DUP ALLOT ERASE VALUE MyDCB

: WaitComm overlap Event commhandle WaitCommEvent DROP Event @ ." Event" . ;

: CommOpen ( addr n -- -1|commhandle ) \ for example string "com1" or "com2"
DROP >R
 0		\   0  COM-
(  FILE_ATTRIBUTE_NORMAL FILE_FLAG_OVERLAPPED OR ) \ 
 0		\    
 OPEN_EXISTING
 0		\   
 0		\   
 GENERIC_READ GENERIC_WRITE OR
 R> CreateFileA
 DUP -1 = IF DROP 0 ELSE TO commhandle -1 THEN
 ;

: CommClose ( -- ior ) commhandle CloseHandle DROP 0 TO commhandle ;

\     
: CommOut ( char -- ) \ worked maybe :-)
       commhandle TransmitCommChar DROP ;

\    
: CommIn ( -- char ) \ WaitComm
        0 WasRead 1 ReadBuffer commhandle ReadFile DROP ReadBuffer C@ ;

\      
: ReadFromComm' ( addr n -- )
	SP@ 0 \ ( addr n &n 0 ) -> ( 0 &N N ADDR )
	SWAP 2SWAP SWAP
	commhandle ReadFile ." [" . ." ]"
	;

: ReadFromComm ( addr n -- ) OVER + SWAP ?DO CommIn I C! LOOP ;

: ReadFromPriz ( addr n -- ) OVER + SWAP ?DO CommIn 0x63 AND I C! LOOP ;

: pause 1000 0 ?DO 5555 7777 * DROP LOOP ;

: WriteToComm ( addr n -- ) OVER + SWAP ?DO I C@ CommOut ( pause ) 1 PAUSE LOOP ;

: Timeouts ( ms -- flag ) \     /  
	 10 CommTimeouts ReadIntervalTimeout !
	  1 CommTimeouts ReadTotalTimeoutMultiplier !
	    CommTimeouts ReadTotalTimeoutConstant !
	100 CommTimeouts WriteTotalTimeoutMultiplier !
	  1 CommTimeouts WriteTotalTimeoutConstant !
	CommTimeouts commhandle SetCommTimeouts 
;
: CommInit ( -- ior ) \   
DCB MyDCB DCBlength !
MyDCB commhandle GetCommState DROP
9600		MyDCB BaudRate ! 
0x80000000 	MyDCB Mode !
8 		MyDCB ByteSize C!
ONESTOPBIT 	MyDCB StopBits C!
NOPARITY 	MyDCB Parity C!
MyDCB commhandle SetCommState 
; 
: SetComm ( BaudRate ByteSize StopBits Parity -- ior )
\  
 MyDCB Parity C!
 MyDCB StopBits C!
 MyDCB ByteSize C!
 MyDCB BaudRate !
 MyDCB commhandle SetCommState 0 <>
;
\ choose port
: COM1 ( -- flag ) S" COM1" CommOpen DUP IF CommInit 1000 Timeouts 2DROP THEN ;
: COM2 ( -- flag ) S" COM2" CommOpen DUP IF CommInit 1000 Timeouts 2DROP THEN ;

\  
: TEST 0 ?DO I CommOut LOOP ;
